#!/bin/bash

gdb -ex "set python print-stack full" -ex "source perf-instrumentation/gdb-port/parser.py" -ex "source perf-instrumentation/gdb-port/utility-commands.py" -ex "source perf-instrumentation/gdb-port/commands.py" -ex "source perf-instrumentation/gdb-port/hammer-breakpoints.py" -ex "source perf-instrumentation/gdb-port/ast.py" -ex "source perf-instrumentation/gdb-port/breakpoint-manager.py" -ex "source perf-instrumentation/gdb-port/top-level-parse.py" -ex "hammer-parse-stop-at-pos 50" -ex "source perf-instrumentation/gdb-port/parser-type-instrumentation-gdb.py" -ex "source perf-instrumentation/gdb-port/parser-name-instrumentation-gdb.py" \
-ex "hammer-parse-step 7" \
-ex "python [gdb.execute('hammer-parse-apply-and-show-ast') for x in range(8)]" \
--args pdf t/000143.pdf

# hammer-parse-step 7 is arbitrary, but happens to get to a location in the file that's convenient for testing token printing

