import unittest
import unittest.mock

#class PerformLowlevelParseRetBreakpointCreated(unittest.TestCase):
#	def test_breakpoint_is_at_ret(self):
#		breakpoint_loc = int(perform_lowlevel_parse_ret.location.lstrip("*"), 16)
#		arch = gdb.selected_frame().architecture()
#		disassembled_ins = arch.disassemble(breakpoint_loc)
#		ins = disassembled_ins[0]['asm'].split(" ")[0]

#		self.assertIn(ins, ["ret", "retq"])

#	def test_not_pending(self):
#		self.assertFalse(perform_lowlevel_parse_ret.pending)

class PerformLowLevelParseRetBreakpointStop(unittest.TestCase):
	def setUp(self):
		self.patcher = unittest.mock.patch('__main__.top_level_parse')
		self.mock_class = self.patcher.start()
		self.plbp = PerformLowLevelParseRetBreakpoint("main")

	def tearDown(self):
		self.patcher.stop() #TODO: make sure we unpatch even if exceptions

	def test_stop(self):
		self.plbp.stop()
		self.assertTrue(self.mock_class.return_from_perform_lowlevel_parse.called)

#class HPackratParseRetBreakpointCreated(unittest.TestCase):
#	def test_breakpoint_is_at_ret(self):
#		breakpoint_loc = int(h_packrat_parse_ret.location.lstrip("*"), 16)
#		arch = gdb.selected_frame().architecture()
#		disassembled_ins = arch.disassemble(breakpoint_loc)
#		ins = disassembled_ins[0]['asm'].split(" ")[0]

#		self.assertIn(ins, ["ret", "retq"])

#	def test_not_pending(self):
#		self.assertFalse(h_packrat_parse_ret.pending)
