#!/bin/bash

gdb \
-ex "set pagination off" \
-ex "set python print-stack full" -ex "source perf-instrumentation/gdb-port/parser.py" -ex "source perf-instrumentation/gdb-port/utility-commands.py" -ex "source perf-instrumentation/gdb-port/commands.py" -ex "source perf-instrumentation/gdb-port/hammer-breakpoints.py" -ex "source perf-instrumentation/gdb-port/ast.py" -ex "source perf-instrumentation/gdb-port/breakpoint-manager.py" -ex "source perf-instrumentation/gdb-port/top-level-parse.py" -ex "hammer-parse-stop-at-pos 50" -ex "source perf-instrumentation/gdb-port/parser-type-instrumentation-gdb.py" -ex "source perf-instrumentation/gdb-port/parser-name-instrumentation-gdb.py" -ex "source perf-instrumentation/gdb-port/tests/unit/top-level-parse.py" -ex "source perf-instrumentation/gdb-port/tests/unit/breakpoint-manager.py" -ex "source perf-instrumentation/gdb-port/tests/unit/hammer-breakpoints.py" -ex "source perf-instrumentation/gdb-port/tests/unit/ast.py" -ex "source perf-instrumentation/gdb-port/tests/run_unittest_main.py" --args pdf t/000143.pdf

